require 'backrub/store/base'
require 'backrub/store/redis'
require 'backrub/version'

module Backrub
  extend self

  attr_writer :store
  def store
    @store ||= Backrub::Store::Redis.new
  end

  def subscribe(channels_with_backlog, &block)
    channels_with_backlog.each do |channel, count|
      store.backlog(channel.to_s, count.to_i, &block) unless count.zero?
    end

    channels = channels_with_backlog.keys.map(&:to_s)

    store.subscribe(*channels, &block)
  end

  def publish(channel, message)
    store.publish(channel, message)
  end
end
